/***********************************************************************************
 *   Copyright (C) 2009 Valerio Orlandini <valerio.orlandini@gmx.com>
 *   Part of this code is based on the simple sine generator developed by
 *   Nedko Arnaudov <nedko@arnaudov.name> and Andreas Kusterer <malaclypse23@gmx.de>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; version 2 of the License
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *   Questo programma è software libero, soggetto ai termini della licenza
 *   GNU General Public License. Può essere modificato e ridistribuito
 *   secondo i termini specificati.
 *   Il presente programma è distribuito senza garanzia alcuna.
 *********************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <time.h>

float sndgen (float a, float b, float c, float d)
{
	/* sound generation... uhuh, here you are welcome to modify every 
	 * value in order to obtain the weirdest sounds. 
	 * Try different values, and adjust them with the experience */
	
	/* another random generation */
	srand(time(NULL));
	float r = rand() / RAND_MAX;
	
	/* a first layer of sound */
	float e = ((a * sin(2 * M_PI * b * c))) / (d * (2 + cos(2 * M_PI * c)));
	
	/* a second layer of sound, that depends by the value of r */
	float f;
	if (r >= 0.67) f = ((a * sin(2.5 * M_PI * b * c))) / (d * (1 + cos(1.5 * M_PI * c)));
	else if (r <= 0.33) f = ((a * sin(1.5 * M_PI * b * c))) / (d * (3 + cos(2.5 * M_PI * c)));
	else f = ((a * cos(2.5 * M_PI * b * c))) / (d * (2 + sin(2.5 * M_PI * c)));
	
	/* sum of the layers, returning the complete sound */
	float t = (e / 2) + (f / 2);
	return t;
}
