/***********************************************************************************
 *   Copyright (C) 2009 Valerio Orlandini <valerio.orlandini@gmx.com>
 *   The base for this work comes from the amplifier example, written by
 *   Steve Harris <http://plugin.org.uk/>, the noise generators from the work of
 * 	 Nick Lamb <njl195@zepler.org.uk> and James W. Morris <james@jwm-art.net>
 * 
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; version 2 of the License
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *   Questo programma è software libero, soggetto ai termini della licenza
 *   GNU General Public License. Può essere modificato e ridistribuito
 *   secondo i termini specificati.
 *   Il presente programma è distribuito senza garanzia alcuna.
 *********************************************************************************/

#include <stdlib.h>
#include <math.h>
#include <stdio.h>
#include <time.h>

float sndgen (          float in,
                        float ino,
                        float cr,
                        float p,
                        float c,
                        float n1vo,
                        float n2vo,
                        double ang,
                        int info
                        ) {

	float out, on2;
        float cosf = cos(ang);
        float sinf = sin(ang);

	/* Noise 1 generation */
	union { float f; unsigned int u; } sample;
	unsigned int exp, man, sign;
	sign = random() % 2;
	exp = random() % 127;
	man = random() % 0x800000;
	if (exp > 0) sample.u = (sign << 31) + (exp << 23) + man;
	else sample.u = (sign << 31);

	/* Noise 2 generation */
	long prc = lrintf(2);
	float r = random() % prc;
	float result = ceilf(r);
	on2 = (result / 2) - 1.0f;

	/* Sending the composite signal to output */
	if (info) out = (((in + (ino * cr)) * cosf - ino * sinf) + (sample.f * n1vo) + (on2 * n2vo))* p * 2 * c;
        else if (!info) out = ((ino * sinf + (in + (ino * cr)) * cosf) + (sample.f * n1vo) + (on2 * n2vo)) * p * 2 * c;
        return out;
}
